module Prek
  class PrekManager
    class Lesson
      class Create < Lesson
        self.summary = ''

        def self.options
          [].concat(super)
        end

        def initialize(params)
          @projectName = params.shift_argument
          @components = params.option('components','optional')
          @prefix = params.option('prefix','Prek')
          @platform =  params.flag?('platform',true)
          super
        end

        def validate!
          super
          if @components && !%w(none optional all).include?(@components)
            help! "`#{@components}' 参数无效，components = none 或 optional 或 all "          
          end

          if !@projectName
            help! "参数错误，需要输入项目名称，bytedance project create projectName"
          end
            
        end

        def run
          super
          parameter = [@projectName,'--components='+ @components,'--prefix=' + @prefix, @platform ? '--platform' : '--no-platform', '--template-url=git@code.byted.org:prek/lesson_pod_template.git']
          finalParams = CLAide::ARGV.new(parameter)
          Pod::Command::Lib::Create.new(finalParams).run
        end
      end
    end
  end
 end